## tmperamental 1.0

=== Makefile ===
prefix		= /usr/
libdir		= ${prefix}/lib
pkglibdir	= ${libdir}/tmperamental
bindir		= ${prefix}/bin

LIBS		= out/libtmperamental.so
PROGRAMS	= out/tmperamental

all: build
build: ${LIBS} ${PROGRAMS}
clean:
	rm -rf out
install: all
	install -d ${DESTDIR}/${pkglibdir} ${DESTDIR}/${bindir}
	install -m 0644 ${LIBS} ${DESTDIR}/${pkglibdir}/
	install -m 0755 ${PROGRAMS} ${DESTDIR}/${bindir}/

.PHONY: all build clean install

out/libtmperamental.so: out/tmperamental.o
	${CC} ${LDFLAGS} -shared -Wl,--no-as-needed -ldl -o $@ $<
out/tmperamental.o: src/tmperamental.c
	install -d out
	${CC} ${CFLAGS} -fPIC -DPIC -c -o $@ $<
out/tmperamental: src/tmperamental.in
	sed -e "s,@pkglibdir@,${pkglibdir},g" <$^ >$@
	chmod +x $@

=== debian/changelog ===
tmperamental (1.0) unstable; urgency=low

  * Initial release.

 -- Paul Tagliamonte <paultag@debian.org>  Tue, 11 Feb 2014 22:14:17 -0500

=== debian/control ===
Source: tmperamental
Section: misc
Priority: optional
Maintainer: Paul Tagliamonte <paultag@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: http://git.debian.org/?p=collab-maint/tmperamental.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/tmperamental.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/tmperamental.git

Package: tmperamental
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LD_PRELOADable library to detect rouge writes to /tmp/
 This friendly library will explode in a huge ball of fire when an application
 tries to write to /tmp, which is hella useful for checking that code respects
 setting TMPDIR (and friends) in the env.

## tmperamental 1.1

=== Makefile ===
prefix		= /usr/
libdir		= ${prefix}lib
pkglibdir	= ${libdir}/tmperamental
bindir		= ${prefix}bin

LIBS		= out/libtmperamental.so
PROGRAMS	= out/tmperamental

ifneq "$(filter Linux GNU%,$(shell uname))" ""
LDLIBS         += -ldl
endif

all: build
build: ${LIBS} ${PROGRAMS}
clean:
	rm -rf out tests/out
install: all
	install -d ${DESTDIR}/${pkglibdir} ${DESTDIR}/${bindir}
	install -m 0644 ${LIBS} ${DESTDIR}/${pkglibdir}/
	install -m 0755 ${PROGRAMS} ${DESTDIR}/${bindir}/

.PHONY: all build clean install

out:
	install -d out
out/libtmperamental.so: out/tmperamental.o out
	${CC} ${LDFLAGS} -shared -Wl,--no-as-needed ${LDLIBS} -o $@ $<
out/tmperamental.o: src/tmperamental.c out
	${CC} ${CFLAGS} ${CPPFLAGS} -Wall -fPIC -DPIC -c -o $@ $<
out/tmperamental: src/tmperamental.in out
	sed -e "s,@pkglibdir@,${pkglibdir},g" <$< >$@
	chmod +x $@

=== debian/changelog ===
tmperamental (1.1) unstable; urgency=medium

  [ Jakub Wilk ]
  * Compile with -Wall.
  * Honour CPPFLAGS.
  * Add support for LFS (open64, creat64, etc.) API.
  * Add the test suite.

  [ Paul Tagliamonte ]
  * Add tests/out to clean

  [ Justin B Rye ]
  * Typofix. (Closes: #738858)

  [ Jakub Wilk ]
  * Explain why _GNU_SOURCE needs to be defined
  * Link with -ldl only of GNU systems
  * Don't include malloc.h
  * Fix type mismatch when sizeof (mode_t) < sizeof (int)
  * Don't split arguments containing spaces (Closes: #862165)

  [ Daniel Kahn Gillmor ]
  * wrap-and-sort -ast
  * move to dh 11
  * Standards-Version: bump to 4.2.1 (no changes needed)
  * move source repositories to salsa.debian.org
  * d/copyright: use secure address of Format
  * Add myself to uploaders
  * de-slangify the package Description
  * added debian/gbp.conf
  * no need for a trailing slash after ${prefix}
  * enable parallel build
  * New release (Closes: #901196)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 27 Aug 2018 21:55:23 -0400

=== debian/control ===
Source: tmperamental
Section: misc
Priority: optional
Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders:
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
Build-Depends:
 debhelper (>= 11),
Standards-Version: 4.2.1
Homepage: https://salsa.debian.org/debian/tmperamental
Vcs-Git: https://salsa.debian.org/debian/tmperamental.git
Vcs-Browser: https://salsa.debian.org/debian/tmperamental

Package: tmperamental
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: LD_PRELOADable library to detect rogue writes to /tmp/
 This friendly library will print a backtrace and abort fire when an
 application tries to write to /tmp.  This is useful for checking that
 code respects setting TMPDIR (and friends) in the env.

## tmperamental 1.1+nmu1

=== debian/changelog ===
tmperamental (1.1+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 19:46:09 +0800

## tmperamental 1.4

=== debian/changelog ===
tmperamental (1.4) unstable; urgency=medium

  * build-test should depend on libc6-dev

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 08 Mar 2020 12:17:06 -0400

tmperamental (1.3) unstable; urgency=medium

  * clean up autopkgtests (ls-nonexistent should return 2, not 0)
  * added "make check"
  * run the upstream tests at autopkgtest time as well

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 07 Mar 2020 01:29:05 -0500

tmperamental (1.2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one

  [ Daniel Kahn Gillmor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * standards-version: bump to 4.5.0 (no changes needed)
  * Rules-Requires-Root: no
  * add hardening options
  * the library is not typically placed directly in /usr/lib
  * Avoid segfaults on earlier initializers (Closes: #941407)
  * added manpage for tmperamental (Closes: #784978)
  * drop unnecessary "fire" from package description (Closes: #909201)
  * added simple autopkgtest

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 06 Mar 2020 17:01:33 -0500

=== debian/control ===
Source: tmperamental
Section: misc
Priority: optional
Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders:
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
Build-Depends:
 debhelper-compat (= 12),
Standards-Version: 4.5.0
Homepage: https://salsa.debian.org/debian/tmperamental
Vcs-Git: https://salsa.debian.org/debian/tmperamental.git
Vcs-Browser: https://salsa.debian.org/debian/tmperamental
Rules-Requires-Root: no

Package: tmperamental
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: LD_PRELOADable library to detect rogue writes to /tmp/
 This friendly library will print a backtrace and abort when an
 application tries to write to /tmp.  This is useful for checking that
 code respects setting TMPDIR (and friends) in the env.

=== debian/tests/control ===
Test-Command: tmperamental ls /
Features: test-name=ls-root

Test-Command: ! tmperamental ls /nonexistent
Features: test-name=ls-nonexistent
Restrictions: allow-stderr

Test-Command: make -C tests preload=LD_PRELOAD=/usr/lib/tmperamental/libtmperamental.so
Features: test-name=build-test
Depends:
 gcc,
 libc6-dev,
 make,
 @,
Restrictions: allow-stderr

Tests: ensure-abort

## tmperamental 1.5

=== debian/changelog ===
tmperamental (1.5) unstable; urgency=medium

  * Unset _TIME_BITS; we don't use time_t in this package (at least not
    directly) (Closes: #1069505)

 -- Paul Tagliamonte <paultag@debian.org>  Sat, 24 May 2025 15:28:31 -0400

## tmperamental 1.6

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 libdir		= ${prefix}lib
 pkglibdir	= ${libdir}/tmperamental
 bindir		= ${prefix}bin
+mandir          = ${prefix}share/man
 
 LIBS		= out/libtmperamental.so
 PROGRAMS	= out/tmperamental
@@ -18,8 +19,12 @@
 	install -d ${DESTDIR}/${pkglibdir} ${DESTDIR}/${bindir}
 	install -m 0644 ${LIBS} ${DESTDIR}/${pkglibdir}/
 	install -m 0755 ${PROGRAMS} ${DESTDIR}/${bindir}/
+	install -d ${DESTDIR}/${pkglibdir} ${DESTDIR}/${mandir}/man1
+	install -m 0644 doc/tmperamental.1 ${DESTDIR}/${mandir}/man1/
+check: build
+	$(MAKE) -C tests
 
-.PHONY: all build clean install
+.PHONY: all build clean install check
 
 out:
 	install -d out

=== tests/Makefile ===
c_files = $(wildcard *.c)
ok_files = $(addprefix out/,$(c_files:.c=.ok32) $(c_files:.c=.ok64))

preload = LD_PRELOAD=../out/libtmperamental.so
assert_aborted = [ $$? -eq 134 ]

.PHONY: all
all: $(ok_files)

%.ok32: %.exe32
	$(preload) $<; $(assert_aborted)
	touch $@

%.ok64: %.exe64
	$(preload) $<; $(assert_aborted)
	touch $@

out/%.exe32: %.c
	mkdir -p out
	$(CC) $(CFLAGS) $(CPPFLAGS) -U_FILE_OFFSET_BITS -Wall -o $@ $<

out/%.exe64: %.c
	mkdir -p out
	$(CC) $(CFLAGS) $(CPPFLAGS) -D_FILE_OFFSET_BITS=64 -Wall -o $@ $<

.PHONY: clean
clean:
	rm -rf out

.PRECIOUS: out/%.exe32 out/%.exe64

=== debian/changelog ===
tmperamental (1.6) unstable; urgency=medium

  * Ok, ok. Actually solve it this time. I didn't unset _TIME_BITS
    in the tests; so this FTBFS agian. This worked this time in an
    armhf chroot, let's take another bite of the apple here.
    (Closes: #1069505)

 -- Paul Tagliamonte <paultag@debian.org>  Sun, 25 May 2025 10:19:34 -0400

## tmperamental 1.6build1

=== debian/changelog ===
tmperamental (1.6build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Wed, 11 Feb 2026 23:46:49 +0100
